#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <../bl_files.h>
#include <../bl_vars.h>
#include <../bl_svga.h>

unsigned short getrgbcolor16 (unsigned char r,unsigned char g,unsigned char b)
  {
   unsigned long color;
   
   color=((r>>3)<<11) + ((g>>2)<<5) + (b>>3);
   return(color);
  }



void draw_sprite(unsigned short x, unsigned short y, unsigned char *spritename)
  {
      
        unsigned short i,j,width,height;
        unsigned short *dest;
        unsigned long sprofs,sprsize;
        unsigned char col,*sprptr,*sprpos;

        sprofs=findfile(resfile,spritename,&sprsize);

        if (sprofs==NULL) return;

        lseek(resfile,sprofs,SEEK_SET);
        _dos_read(resfile,&width,2,1); //width of sprite
        _dos_read(resfile,&height,2,1); //height of sprite
        
        _dos_read(resfile,&palette,768,1); //palette

        sprptr=(unsigned char*)calloc(width,1);

        dest=(unsigned short *)Videobuf; // 
        dest+=640*y+x;
        for(i = 0; i < height; i++)
          {
           _dos_read(resfile,sprptr,width,1);
           sprpos=sprptr;
           for(j = 0; j < width; j++)
             {
                 *dest=getrgbcolor16(palette[*sprpos][2],palette[*sprpos][1],palette[*sprpos][0]);
                 dest++;
                 sprpos++;
             }
           dest+=(640-width);
          }
        
  }

void draw_spritet(unsigned short x, unsigned short y, unsigned char *spritename,unsigned char transp)
  {
        unsigned short i,j,width,height;
        unsigned short *dest;
        unsigned long sprofs,sprsize;
        unsigned char col,*sprptr,*sprpos;

        sprofs=findfile(resfile,spritename,&sprsize);

        if (sprofs==NULL) return;

        lseek(resfile,sprofs,SEEK_SET);
        _dos_read(resfile,&width,2,1); //width of sprite
        _dos_read(resfile,&height,2,1); //height of sprite
        _dos_read(resfile,&palette,768,1); //palette

        sprptr=(unsigned char*)calloc(width,1);

        dest=(unsigned short *)Videobuf; // 
        dest+=640*y+x;
        for(i = 0; i < height; i++)
          {
           _dos_read(resfile,sprptr,width,1);
           sprpos=sprptr;
           for(j = 0; j < width; j++)
             {
                 if (*sprpos!=transp) *dest=getrgbcolor16(palette[*sprpos][2],palette[*sprpos][1],palette[*sprpos][0]);
                 dest++;
                 sprpos++;
             }
           dest+=(640-width);
          }
       
  }

void draw_spritea(unsigned short x, unsigned short y, unsigned char *spritename,
                  unsigned char r,unsigned char g,unsigned char b)
  {
        unsigned short i,j,width,height;
        unsigned short *dest;
        unsigned long sprofs,sprsize;
        unsigned char *sprptr,*sprpos;

        sprofs=findfile(resfile,spritename,&sprsize);

        if (sprofs==NULL) return;

        lseek(resfile,sprofs,SEEK_SET);
        _dos_read(resfile,&width,2,1); //width of sprite
        _dos_read(resfile,&height,2,1); //height of sprite

        sprptr=(unsigned char*)calloc(width,1);

        dest=(unsigned short *)Videobuf; // 
        dest+=640*y+x;
        for(i = 0; i < height; i++)
          {
           _dos_read(resfile,sprptr,width,1);
           sprpos=sprptr;
           for(j = 0; j < width; j++)
             {
                 if (*sprpos)
                   {
                       *dest=getrgbcolor16(*sprpos*r/255,*sprpos*g/255,*sprpos*b/255);
                   }
                 dest++;
                 sprpos++;
             }
           dest+=(640-width);
          }
       
  }


void upscale32(unsigned long *source,unsigned long *dest, unsigned long sw,
                unsigned long sh,unsigned long dw,unsigned long dh)
  {
   unsigned long i,j,*sa,*da,adr,adr1;
   float adx,ady,x,y;
   
  adx=sw/dw;
  ady=sh/dh;
  x=0; y=0; adr=0;
  da=dest;
  for (i=0;i<dh;i++)
    {
       for (j=0;j<dw;j++)
         {
             adr1=640*ady+adx;
             sa=source+(adr1<<2);
             da+=adr;
             *da=*sa;
             x+=adx;
             adr++;
         }
       y+=ady;
       x=0;
    }
  }

void loadbkgrnd(unsigned char *spritename,unsigned short *buf)
  {
      unsigned short i,j,width,height;
      unsigned short *dest;
      unsigned long sprofs,sprsize;
      unsigned char *sprptr,*sprpos;

      sprofs=findfile(resfile,spritename,&sprsize);
      printf("%d %d \n",sprofs,sprsize);

      if (sprofs==NULL) return;

      lseek(resfile,sprofs,SEEK_SET);
      _dos_read(resfile,&width,2,1); //width of sprite
      _dos_read(resfile,&height,2,1); //height of sprite
      if ((width!=640) || (height!=480)) return;
      

      _dos_read(resfile,&palette,768,1); //palette

      dest=(unsigned short *)buf; // 
      sprptr=(unsigned char*)calloc(width,1);
      
      for(i = 0; i < height; i++)
        {
         _dos_read(resfile,sprptr,width,1);
         sprpos=sprptr;
         for(j = 0; j < width; j++)
           {
               *dest=getrgbcolor16(palette[*sprpos][2],palette[*sprpos][1],palette[*sprpos][0]);
               dest++;
               sprpos++;
           }
        }
  }


