
/*
** lzwlib.h - lzwlib main header file,
** Copyright (c) 1998-2006, Zealot
*/

#ifndef __LZWLIB_H
#define __LZWLIB_H

/* Types */
typedef unsigned char Byte;
typedef unsigned int Dword;

/* Internal declarations */
typedef struct tagLZWENTRY {
        Dword substrIndex;
        Dword substrSize;
        Dword next;
} LZWENTRY;//, *PLZWENTRY;

/***********************************************/
/*           LZWLIB PUBLIC INTERFACE           */
/***********************************************/

/* Compression */
Dword lzwGetRequiredMemSize(Dword bSize);
Dword lzwCompress_file(unsigned char *infile,unsigned char *outfile);
Dword lzwCompress(Byte *data, Dword bSize, Byte *buff);
Dword lzwGetDoneCompressWork();

/* Decompression */
Dword lzwGetDecompressedSize(Byte *compressedData);
Dword lzwDecompress(Byte *data, Dword bSize, Byte *buff);
Dword lzwGetDoneDecompressWork();
const char *lzwGetErrorCodeString(Dword errCode);

/* Error codes */
#define ERROR_INVALID_LZW_SIGNATURE 0x01
#define ERROR_INVALID_CRC32         0x02
#define ERROR_DATA_IS_CURRUPTED     0x03
#define ERROR_DATA_IS_CURRUPTED2    0x04
#define ERROR_HEADER_IS_CORRUPTED   0x05

#endif
